# The pyGLV package

## pyGLV (computer **G**raphics for deep **L**earning and scientific **V**isualization)

A python, pure software design pattern based package that used plain and simple **E**ntities, **C**omponents and **S**ystems in a **S**cenegraph architecture from thge `pyECSS` package, in order to showcase basic, cross-platform OpenGL-based real-time computer graphics with applications to scientific visualization and deep learning.

---


> **Why GLV?**:
>
> This package is aimed as a basic behind-the-black-box implementation of several classic as well as modern computer graphics  methodologies, algorithms and techniques, aimed for teaching as well as framework for novel research.

The following software design patterns are employed:

- Decorator Pattern: *RenderDecorator, ComponentDecorator, SystemDecorator*
- game-loop pattern (GPP non GoF): *Scene*

## Installation

- For `standalone` use, via `pip`

  ```
  pip install pyglv
  ```

- For `development`: via `github`

  ```
  git clone .......
  ```

  and in order to install it `locally` via `pip`:

  ```
  python -m pip install -e .
  ```

## Contributors

- Prof. George Papagiannakis
- Dr. Kamarianakis Manos
- Geronikolakis Stratos
- Zack Pervolarakis
- George Kokiadis
  
---

### *Copyright 2021-2022 Dr. George Papagiannakis,  papagian@csd.uoc.gr*

### *All Rights Reserved*

### *University of Crete & Foundation for Research & Technology - Hellas (FORTH)*

---
## Licensing

pyGLV is licensed under the Apache License, Version 2.0. See
LICENSE.txt for the full license text.
